unit Unit2;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Buttons, Spin,Unit6,UnitScaleFont,LCLType;

type

  { Tmodif_element }

  Tmodif_element = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Edit_logk: TEdit;
    Edit_reactionformation: TEdit;
    Edit_rayon: TEdit;
    Edit_conductivite: TEdit;
    Edit_massemolaire: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    ListBox_soustypeorganique: TComboBox;
    Label6: TLabel;
    ListBox_soustypenonorganique: TComboBox;
    Label5: TLabel;
    ListBox_type: TComboBox;
    Edit_formule: TEdit;
    Edit_centesimale: TEdit;
    Edit_synonyme: TEdit;
    Edit_identifiant: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label7: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpinEdit1: TSpinEdit;
    procedure BitBtn1Click(Sender: TObject);
    procedure Edit_reactionformationClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  modif_element: Tmodif_element;

implementation
uses modif_1;
{ Tmodif_element }

procedure Tmodif_element.BitBtn1Click(Sender: TObject);
begin
if indice_element_base(identifiant_element_a_modifier)=0 then
try
strtofloat(modif_element.Edit_logk.Text);
except
application.MessageBox('Erreur de syntaxe pour la valeur de log K !',
'Attention !',mb_ok);
modalresult:=0;
end;

if modif_element.Edit_conductivite.Enabled then
try
strtofloat(modif_element.Edit_conductivite.Text);
except
application.MessageBox('Erreur de syntaxe pour la valeur de la conductivité !',
'Attention !',mb_ok);
modalresult:=0;
end;

if modif_element.Edit_rayon.Enabled then
try
strtofloat(modif_element.Edit_rayon.Text);
except
application.MessageBox('Erreur de syntaxe pour la valeur du rayon !',
'Attention !',mb_ok);
modalresult:=0;
end;


end;

procedure Tmodif_element.Edit_reactionformationClick(Sender: TObject);
var res,i,k:integer;
begin
if modif_1.mode_creation then exit;
if indice_element_base(identifiant_element_a_modifier)<>0 then exit;
form6:=tform6.create(self);
k:=indice_element_aqueux(identifiant_element_a_modifier);
if k<>0 then
for i:=1 to tableau_elements_aqueux[k-1].nombre_composants do
if form6.ListBox2.Items.IndexOf(tableau_elements_aqueux[k-1].
composition[i-1].element)=-1 then
form6.ListBox2.Items.Add(tableau_elements_aqueux[k-1].
composition[i-1].element);

k:=indice_element_mineral(identifiant_element_a_modifier);
if k<>0 then
for i:=1 to tableau_elements_mineraux[k-1].nombre_composants do
if form6.ListBox2.Items.IndexOf(tableau_elements_mineraux[k-1].
composition[i-1].element)=-1 then
form6.ListBox2.Items.Add(tableau_elements_mineraux[k-1].
composition[i-1].element);

k:=indice_element_organique(identifiant_element_a_modifier);
if k<>0 then
for i:=1 to tableau_elements_organiques[k-1].nombre_composants do
if form6.ListBox2.Items.IndexOf(tableau_elements_organiques[k-1].
composition[i-1].element)=-1 then
form6.ListBox2.Items.Add(tableau_elements_organiques[k-1].
composition[i-1].element);

k:=indice_element_aqueux(identifiant_element_a_modifier);
if k<>0 then begin
setlength(modif_1.newcompo,tableau_elements_aqueux[k-1].nombre_composants_atomiques);
for i:=1 to  tableau_elements_aqueux[k-1].nombre_composants_atomiques do
modif_1.newcompo[i-1]:=tableau_elements_aqueux[k-1].composition_atomique[i-1];
end;

k:=indice_element_mineral(identifiant_element_a_modifier);
if k<>0 then begin
setlength(modif_1.newcompo,tableau_elements_mineraux[k-1].nombre_composants_atomiques);
for i:=1 to  tableau_elements_mineraux[k-1].nombre_composants_atomiques do
modif_1.newcompo[i-1]:=tableau_elements_mineraux[k-1].composition_atomique[i-1];
end;

k:=indice_element_organique(identifiant_element_a_modifier);
if k<>0 then begin
setlength(modif_1.newcompo,tableau_elements_organiques[k-1].nombre_composants_atomiques);
for i:=1 to  tableau_elements_organiques[k-1].nombre_composants_atomiques do
modif_1.newcompo[i-1]:=tableau_elements_organiques[k-1].composition_atomique[i-1];
end;

repeat
res:=form6.ShowModal;
until ((res=mrok) or (res=mrcancel));

equation_modifiee:=(res=mrok);
if equation_modifiee then
modif_element.Edit_reactionformation.Text:=form6.Edit1.Text;
form6.close;

end;

procedure Tmodif_element.FormShow(Sender: TObject);
begin
 // scalefont(self);
end;

initialization
  {$I unit2.lrs}

end.

