unit Unit4; 

{$mode objfpc}{$H+}

interface

uses
Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Buttons, Grids, ExtCtrls,math,UChaines,UnitScaleFont,LCLType;
type

  { TForm4 }

  TForm4 = class(TForm)
    BitBtn2: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Editformulebrute: TEdit;
    BitBtn1: TBitBtn;
    Label4: TLabel;
    RadioGroup1: TRadioGroup;
    sgreactifs: TStringGrid;
    Label3: TLabel;
SpeedButtonC: TSpeedButton;
    SpeedButtonO: TSpeedButton;
    SpeedButtonH: TSpeedButton;
    SpeedButtonN: TSpeedButton;
    SpeedButtonP: TSpeedButton;
    SpeedButtonS: TSpeedButton;
    SpeedButton1plus: TSpeedButton;
    SpeedButton2plus: TSpeedButton;
    SpeedButton3plus: TSpeedButton;
    SpeedButton3moins: TSpeedButton;
    SpeedButton2moins: TSpeedButton;
    SpeedButton1moins: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    procedure BitBtn1Click(Sender: TObject);
    procedure EditformulebruteChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure sgreactifsMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
procedure SpeedButtonCClick(Sender: TObject);
    procedure SpeedButtonOClick(Sender: TObject);
    procedure SpeedButtonHClick(Sender: TObject);
    procedure SpeedButtonNClick(Sender: TObject);
    procedure SpeedButtonPClick(Sender: TObject);
    procedure SpeedButtonSClick(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton1plusClick(Sender: TObject);
    procedure SpeedButton2plusClick(Sender: TObject);
    procedure SpeedButton3plusClick(Sender: TObject);
    procedure SpeedButton3moinsClick(Sender: TObject);
    procedure SpeedButton2moinsClick(Sender: TObject);
    procedure SpeedButton1moinsClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form4: TForm4;
 largeur_col1_reactifs,largeur_col2_reactifs,largeur_col3_reactifs,largeur_col4_reactifs:integer;
 id4:string;
implementation
 uses Unit3,Modif_1;



procedure TForm4.BitBtn1Click(Sender: TObject);

var toto:tstringlist; i,didi:integer;
tyty:comparaison_entre_formules_brutes;
begin
 if editformulebrute.Text='' then exit;
 case radiogroup1.ItemIndex of
 0: tyty:=egal;
 1: tyty:=inf;
 2: tyty:=sup;
 3: tyty:=parmi;
 end;
toto:=tstringlist.Create;
if not(ReactifsDeFormuleBrute(editformulebrute.Text,toto,true,tyty)) then begin
application.MessageBox(pchar(rsLaSyntaxeDeV), pchar(rsAttention2), mb_ok);
exit end;
if toto.Count=0 then begin
sgreactifs.RowCount:=1;
application.MessageBox(pchar(rsAucuneEspCeA3), pchar(rsAttention2), mb_ok);
exit end;

sgreactifs.Cells[0, 0]:=rsIdentifiant;
  sgreactifs.Cells[1, 0]:=rsSynonyme;
  sgreactifs.Cells[2, 0]:=rsFormuleBrute2;
  sgreactifs.Cells[3, 0]:=rsMGMol;

  sgreactifs.AutoSizeColumns;

  
sgreactifs.RowCount:=1+toto.Count;
for i:=1 to toto.Count do  begin
sgreactifs.Cells[0,i]:=toto[i-1];
case DonneNatureReactif(toto[i-1],didi) of
debase: begin
sgreactifs.Cells[3,i]:=floattostr(
tableau_elements_base[didi-1].masse_molaire);
sgreactifs.Cells[1,i]:=
tableau_elements_base[didi-1].synonyme;
sgreactifs.Cells[2,i]:='';
end;
aqueux: begin
sgreactifs.Cells[3,i]:=floattostr(
tableau_elements_aqueux[didi-1].masse_molaire);
sgreactifs.Cells[1,i]:=
tableau_elements_aqueux[didi-1].synonyme;
sgreactifs.Cells[2,i]:=tableau_elements_aqueux[didi-1].formule;
end;
gaz: sgreactifs.Cells[3,i]:=floattostr(
tableau_elements_gazeux[didi-1].masse_molaire);
solide: begin
sgreactifs.Cells[3,i]:=floattostr(
tableau_elements_mineraux[didi-1].masse_molaire);
sgreactifs.Cells[1,i]:=
tableau_elements_mineraux[didi-1].synonyme;
sgreactifs.Cells[2,i]:=tableau_elements_mineraux[didi-1].formule;
end;
organique: begin
sgreactifs.Cells[3,i]:=floattostr(
tableau_elements_organiques[didi-1].masse_molaire);
sgreactifs.Cells[1,i]:=
tableau_elements_organiques[didi-1].synonyme;
sgreactifs.Cells[2,i]:=tableau_elements_organiques[didi-1].formule;
end;
end;



  sgreactifs.AutoSizeColumns;


  end;
toto.Free;


end;

procedure TForm4.EditformulebruteChange(Sender: TObject);
begin

//form4.Editformulebrute.SelLength := 0;
//form4.Editformulebrute.SelStart:=length(form4.Editformulebrute.text)+1;
//application.MessageBox(pchar(inttostr(length(form4.Editformulebrute.text))),
//pchar(inttostr(form4.Editformulebrute.SelStart)),mb_ok);
end;

procedure TForm4.FormCreate(Sender: TObject);
var toto:tstringlist;
begin

sgreactifs.ColCount:=4;
  sgreactifs.RowCount:=2;
  sgreactifs.Cells[0, 0]:='Identifiant';
  sgreactifs.Cells[1, 0]:='Synonyme';
  sgreactifs.Cells[2, 0]:='Formule brute';
  sgreactifs.Cells[3, 0]:='M (g/mol)';

  sgreactifs.AutoSizeColumns;



end;

procedure TForm4.FormShow(Sender: TObject);
begin
 // scalefont(self);
end;

procedure TForm4.sgreactifsMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var  i,coco,roro:integer;
deja_entre:boolean;
repmode:integer;
label 555,666;
  begin
sgreactifs.MouseToCell(x,y,coco,roro);
if ((roro>0)   and (roro<=sgreactifs.rowcount-1) and
(coco>=0) and (coco<=sgreactifs.ColCount-1)
and( sgreactifs.Cells[0,roro]<>'') )  then
begin
id4:=sgreactifs.Cells[0,roro];
close;
end;

end;

procedure TForm4.SpeedButtonCClick(Sender: TObject);
var s:string;  p:integer;
begin
s:=Form4.editformulebrute.Text;
p:=Form4.editformulebrute.SelStart;
insert('C',s,p+1);
Form4.editformulebrute.Text:=s;
form4.Editformulebrute.SelStart:=p+1;
end;

procedure TForm4.SpeedButtonOClick(Sender: TObject);
var s:string;  p:integer;
begin
s:=Form4.editformulebrute.Text;
p:=Form4.editformulebrute.SelStart;
insert('O',s,p+1);
Form4.editformulebrute.Text:=s;
form4.Editformulebrute.SelStart:=p+1;
end;

procedure TForm4.SpeedButtonHClick(Sender: TObject);
var s:string;  p:integer;
begin
s:=Form4.editformulebrute.Text;
p:=Form4.editformulebrute.SelStart;
insert('H',s,p+1);
Form4.editformulebrute.Text:=s;
form4.Editformulebrute.SelStart:=p+1;
end;

procedure TForm4.SpeedButtonNClick(Sender: TObject);
var s:string;  p:integer;
begin
s:=Form4.editformulebrute.Text;
p:=Form4.editformulebrute.SelStart;
insert('N',s,p+1);
Form4.editformulebrute.Text:=s;
form4.Editformulebrute.SelStart:=p+1;
end;

procedure TForm4.SpeedButtonPClick(Sender: TObject);
var s:string;  p:integer;
begin
s:=Form4.editformulebrute.Text;
p:=Form4.editformulebrute.SelStart;
insert('P',s,p+1);
Form4.editformulebrute.Text:=s;
form4.Editformulebrute.SelStart:=p+1;
end;

procedure TForm4.SpeedButtonSClick(Sender: TObject);
var s:string;  p:integer;
begin
s:=Form4.editformulebrute.Text;
p:=Form4.editformulebrute.SelStart;
insert('S',s,p+1);
Form4.editformulebrute.Text:=s;
form4.Editformulebrute.SelStart:=p+1;
end;

procedure TForm4.SpeedButton2Click(Sender: TObject);
var s:string;  p:integer;
begin
s:=Form4.editformulebrute.Text;
p:=Form4.editformulebrute.SelStart;
insert('2',s,p+1);
Form4.editformulebrute.Text:=s;
form4.Editformulebrute.SelStart:=p+1;
end;

procedure TForm4.SpeedButton3Click(Sender: TObject);
var s:string;  p:integer;
begin
s:=Form4.editformulebrute.Text;
p:=Form4.editformulebrute.SelStart;
insert('3',s,p+1);
Form4.editformulebrute.Text:=s;
form4.Editformulebrute.SelStart:=p+1;
end;

procedure TForm4.SpeedButton1plusClick(Sender: TObject);
begin
editformulebrute.Text:=editformulebrute.Text+'[+]';
form4.Editformulebrute.SelStart:=length(editformulebrute.Text);
end;

procedure TForm4.SpeedButton2plusClick(Sender: TObject);
begin
editformulebrute.Text:=editformulebrute.Text+'[2+]';
form4.Editformulebrute.SelStart:=length(editformulebrute.Text);
end;

procedure TForm4.SpeedButton3plusClick(Sender: TObject);
begin
editformulebrute.Text:=editformulebrute.Text+'[3+]';
form4.Editformulebrute.SelStart:=length(editformulebrute.Text);
end;

procedure TForm4.SpeedButton3moinsClick(Sender: TObject);
begin
editformulebrute.Text:=editformulebrute.Text+'[3-]';
form4.Editformulebrute.SelStart:=length(editformulebrute.Text);
end;

procedure TForm4.SpeedButton2moinsClick(Sender: TObject);
begin
editformulebrute.Text:=editformulebrute.Text+'[2-]';
form4.Editformulebrute.SelStart:=length(editformulebrute.Text);
end;

procedure TForm4.SpeedButton1moinsClick(Sender: TObject);
begin
editformulebrute.Text:=editformulebrute.Text+'[-]';
form4.Editformulebrute.SelStart:=length(editformulebrute.Text);
end;

initialization
 {$I unit4.lrs}
end.

