unit Unit6;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Buttons,UnitGaussJordan,pivotgauss,UnitScaleFont,LCLType;

type

  { TForm6 }

  TForm6 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form6: TForm6;

implementation
 uses Unit2, Unit4, Unit9,modif_1;
{ TForm6 }

procedure TForm6.FormCreate(Sender: TObject);
var i:integer;
begin
listbox1.Clear;
listbox2.Clear;
listbox2.Items.Add(modif_element.edit_identifiant.text);
listbox2.Items.Add('H2O');
for i:=1 to liste_identifiants.Count do
listbox1.Items.Add(liste_identifiants[i-1]);

end;

procedure TForm6.FormShow(Sender: TObject);
begin
 //scalefont(self);
end;

procedure TForm6.BitBtn1Click(Sender: TObject);
begin
  if edit1.Text='' then modalresult:=mrignore;
end;

procedure TForm6.SpeedButton1Click(Sender: TObject);
begin
  if listbox1.Itemindex<>-1 then
if listbox2.Items.IndexOf(listbox1.Items[listbox1.Itemindex])=-1
then
if not(
(indice_element_mineral(listbox1.Items[listbox1.Itemindex])<>0)
and
(modif_element.ListBox_type.ItemIndex=1)
)
then
listbox2.Items.Add(listbox1.Items[listbox1.Itemindex]) else
 application.MessageBox('Il est interdit d''utiliser un solide pour en former un autre...',
'Hélas !',mb_ok);
end;

procedure TForm6.SpeedButton2Click(Sender: TObject);
begin
  if listbox2.ItemIndex>0 then
listbox2.Items.Delete(listbox2.ItemIndex);
end;

procedure TForm6.SpeedButton3Click(Sender: TObject);
var potentiel_standard_0:tableaureel;
deltarG0_0,logK_0:tableaureel;
temperature:extended;
 nombre_especes,nombre_atomes,rang,reac,i:integer;
 a,aaa,coefficients_stoechiometriques:matricereelle;
 identifiants,formules_brutes,reactions,equations_conservation,equations_avancements:tableaustring;
  nombres_moles,bbb:tableaureel;
  label 134;
begin
nombre_especes:=listbox2.Items.Count;
setlength(logK_0,0);
setlength(deltarG0_0,0);
setlength(potentiel_standard_0,nombre_especes);
setlength(formules_brutes,nombre_especes);
setlength(nombres_moles,nombre_especes);
setlength(identifiants,nombre_especes);
for i:=1 to nombre_especes do  identifiants[i-1]:=
listbox2.Items[i-1];
FormuleBruteExacteDeCompositionAtomique(formules_brutes[0],modif_1.newcompo);
for i:=1 to nombre_especes-1 do
begin
if
indice_element_base(listbox2.Items[i])<>0 then
FormuleBruteExacteDeCompositionAtomique(formules_brutes[i],
tableau_elements_base[indice_element_base(listbox2.Items[i])-1].composition_atomique);
if
indice_element_aqueux(listbox2.Items[i])<>0 then
FormuleBruteExacteDeCompositionAtomique(formules_brutes[i],
tableau_elements_aqueux[indice_element_aqueux(listbox2.Items[i])-1].composition_atomique);
{if
indice_element_gazeux(listbox2.Items[i])<>0 then
FormuleBruteExacteDeCompositionAtomique(formules_brutes[i],
tableau_elements_gazeux[indice_element_gazeux(listbox2.Items[i])-1].composition_atomique); }
if
indice_element_mineral(listbox2.Items[i])<>0 then
FormuleBruteExacteDeCompositionAtomique(formules_brutes[i],
tableau_elements_mineraux[indice_element_mineral(listbox2.Items[i])-1].composition_atomique);
if
indice_element_organique(listbox2.Items[i])<>0 then
FormuleBruteExacteDeCompositionAtomique(formules_brutes[i],
tableau_elements_organiques[indice_element_organique(listbox2.Items[i])-1].composition_atomique);
end;
temperature:=298;
DonneMatriceCoefficients(formules_brutes,a,nombre_especes,nombre_atomes);
DetermineReactions(a,nombres_moles,nombre_especes,nombre_atomes,identifiants,formules_brutes,rang,reac,
reactions,equations_conservation,equations_avancements,aaa,bbb,coefficients_stoechiometriques,
potentiel_standard_0,deltarG0_0,logK_0,temperature,1);
if reac=0 then begin
application.MessageBox('Impossible d''équilibrer avec ces espèces !','Attention !',
mb_ok);
 goto 134;
end;
 if reac>1 then begin
application.MessageBox('Trop d''espèces imposées !','Attention !',
mb_ok);
  goto 134;
end;
if ((reac=1) and (coefficients_stoechiometriques[0,0]=0)) then begin
 application.MessageBox('Impossible d''équilibrer avec ces espèces !','Attention !',
mb_ok);
 goto 134;
end;

edit1.Text:=reactions[0];

modif_1.new_nombre_composants:=0;
modif_1.new_masse_molaire:=0;
for i:=2 to nombre_especes do
if coefficients_stoechiometriques[0,i-1]<>0 then begin
inc(modif_1.new_nombre_composants);
setlength(modif_1.new_composition,modif_1.new_nombre_composants);
modif_1.new_composition[modif_1.new_nombre_composants-1].coefficient:=-coefficients_stoechiometriques[0,i-1];
modif_1.new_composition[modif_1.new_nombre_composants-1].element:=identifiants[i-1];
if  indice_element_base(identifiants[i-1])<>0 then begin
modif_1.new_composition[modif_1.new_nombre_composants-1].nature:=debase;
modif_1.new_composition[modif_1.new_nombre_composants-1].indice_dans_sa_base:=indice_element_base(identifiants[i-1]);
modif_1.new_masse_molaire:=modif_1.new_masse_molaire-
tableau_elements_base[indice_element_base(identifiants[i-1])-1].masse_molaire*
 coefficients_stoechiometriques[0,i-1];
end;
if  indice_element_aqueux(identifiants[i-1])<>0 then begin
modif_1.new_composition[modif_1.new_nombre_composants-1].nature:=aqueux;
modif_1.new_composition[modif_1.new_nombre_composants-1].indice_dans_sa_base:=indice_element_aqueux(identifiants[i-1]);
modif_1.new_masse_molaire:=modif_1.new_masse_molaire-
tableau_elements_aqueux[indice_element_aqueux(identifiants[i-1])-1].masse_molaire*
 coefficients_stoechiometriques[0,i-1];
 end;
if  indice_element_mineral(identifiants[i-1])<>0 then begin
modif_1.new_composition[modif_1.new_nombre_composants-1].nature:=solide;
modif_1.new_composition[modif_1.new_nombre_composants-1].indice_dans_sa_base:=indice_element_mineral(identifiants[i-1]);
modif_1.new_masse_molaire:=modif_1.new_masse_molaire-
tableau_elements_mineraux[indice_element_mineral(identifiants[i-1])-1].masse_molaire*
 coefficients_stoechiometriques[0,i-1];
 end;
{if  indice_element_gazeux(identifiants[i-1])<>0 then begin
modif_1.new_composition[modif_1.new_nombre_composants-1].nature:=gaz;
modif_1.new_composition[modif_1.new_nombre_composants-1].indice_dans_sa_base:=indice_element_gazeux(identifiants[i-1]);
modif_1.new_masse_molaire:=modif_1.new_masse_molaire-
tableau_elements_gazeux[indice_element_gazeux(identifiants[i-1])-1].masse_molaire*
 coefficients_stoechiometriques[0,i-1];
 end;  }
if  indice_element_organique(identifiants[i-1])<>0 then begin
modif_1.new_composition[modif_1.new_nombre_composants-1].nature:=organique;
modif_1.new_composition[modif_1.new_nombre_composants-1].indice_dans_sa_base:=indice_element_organique(identifiants[i-1]);
modif_1.new_masse_molaire:=modif_1.new_masse_molaire-
tableau_elements_organiques[indice_element_organique(identifiants[i-1])-1].masse_molaire*
 coefficients_stoechiometriques[0,i-1];
 end;
end;

134: finalize(potentiel_standard_0);
finalize(deltarG0_0);
finalize(logK_0);
finalize(formules_brutes);
finalize(nombres_moles);
finalize(identifiants);
finalize(a);
finalize(reactions);
finalize(equations_conservation);
finalize(equations_avancements);
finalize(coefficients_stoechiometriques);
 finalize(aaa);
 finalize(bbb);

end;

procedure TForm6.SpeedButton4Click(Sender: TObject);
begin
  form4:=tform4.create(self);
with form4
do begin
if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
end;
form4.Hide;
form4.showmodal;
if Unit4.id4<>'' then begin
if ((indice_element_mineral(Unit4.id4)<>0) and
(modif_element.ListBox_type.ItemIndex=1)) then
application.MessageBox('Il est interdit d''utiliser un solide pour en former un autre...',
'Hélas !',mb_ok) else
 listbox2.Items.add(Unit4.id4);
end;
form4.close;
end;

procedure TForm6.SpeedButton5Click(Sender: TObject);
var i:integer; s:string;
begin
listbox2.Items.Add('H[+]');
listbox2.Items.Add('O2(aq)');
for i:=1 to high(newcompo)+1 do
if newcompo[i-1].numero_atomique<>-1 then
begin
s:=Donne_Representant(tableau_periodique[newcompo[i-1].numero_atomique-1].symbole);
if listbox2.Items.IndexOf(s)=-1
then listbox2.Items.Add(s);
end;

end;

procedure TForm6.SpeedButton6Click(Sender: TObject);
  var i:integer;
begin
if listbox2.Items.Count>1 then
for i:=1 to  listbox2.Items.Count-1 do
listbox2.Items.Delete(1);
end;

procedure TForm6.SpeedButton7Click(Sender: TObject);
begin
  form9:=tform9.create(self);
with form9
do begin
if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
end;
form9.Hide;
form9.showmodal;
if Unit9.id9<>'' then begin
if ((indice_element_mineral(Unit9.id9)<>0) and
(modif_element.ListBox_type.ItemIndex=1)) then
application.MessageBox('Il est interdit d''utiliser un solide pour en former un autre...',
'Hélas !',mb_ok) else
 listbox2.Items.add(Unit9.id9);
end;
form9.close;
end;

initialization
  {$I unit6.lrs}

end.

