unit Unit9;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Grids, Buttons,UnitScaleFont,LCLType;

type

  { TForm9 }

  TForm9 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Editformulebrute: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    sgreactifs: TStringGrid;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure sgreactifsMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form9: TForm9;
   largeur_col1_reactifs,largeur_col2_reactifs,largeur_col3_reactifs:integer;
 id9:string;
implementation
 uses Unit3, modif_1;
{ TForm9 }

procedure TForm9.BitBtn1Click(Sender: TObject);

var toto:tstringlist; i,didi:integer;
begin
 if editformulebrute.Text='' then exit;
toto:=tstringlist.Create;

for i:=1 to nombre_elements_base do
if (pos(lowercase(editformulebrute.Text),lowercase(tableau_elements_base[i-1].identifiant))<>0) or
 (pos(lowercase(editformulebrute.Text),lowercase(tableau_elements_base[i-1].synonyme))<>0)
then toto.Add(tableau_elements_base[i-1].identifiant);

 for i:=1 to nombre_elements_mineraux do
if (pos(lowercase(editformulebrute.Text),lowercase(tableau_elements_mineraux[i-1].identifiant))<>0) or
 (pos(lowercase(editformulebrute.Text),lowercase(tableau_elements_mineraux[i-1].synonyme))<>0)
then toto.Add(tableau_elements_mineraux[i-1].identifiant);

for i:=1 to nombre_elements_aqueux do
if (pos(lowercase(editformulebrute.Text),lowercase(tableau_elements_aqueux[i-1].identifiant))<>0) or
 (pos(lowercase(editformulebrute.Text),lowercase(tableau_elements_aqueux[i-1].synonyme))<>0)
then toto.Add(tableau_elements_aqueux[i-1].identifiant);

for i:=1 to nombre_elements_organiques do
if (pos(lowercase(editformulebrute.Text),lowercase(tableau_elements_organiques[i-1].identifiant))<>0) or
 (pos(lowercase(editformulebrute.Text),lowercase(tableau_elements_organiques[i-1].synonyme))<>0)
then toto.Add(tableau_elements_organiques[i-1].identifiant);


if toto.Count=0 then begin
application.MessageBox('Aucune espéce ayant cette formule n''a été trouvée dans la base.','Attention !',
mb_ok);
exit end;

sgreactifs.RowCount:=1+toto.Count;
for i:=1 to toto.Count do  begin
sgreactifs.Cells[0,i]:=toto[i-1];
case DonneNatureReactif(toto[i-1],didi) of
debase: sgreactifs.Cells[2,i]:=floattostr(
tableau_elements_base[didi-1].masse_molaire);
aqueux: sgreactifs.Cells[2,i]:=floattostr(
tableau_elements_aqueux[didi-1].masse_molaire);
gaz: sgreactifs.Cells[2,i]:=floattostr(
tableau_elements_gazeux[didi-1].masse_molaire);
solide: sgreactifs.Cells[2,i]:=floattostr(
tableau_elements_mineraux[didi-1].masse_molaire);
organique: sgreactifs.Cells[2,i]:=floattostr(
tableau_elements_organiques[didi-1].masse_molaire);
end;
case DonneNatureReactif(toto[i-1],didi) of
debase: sgreactifs.Cells[1,i]:=
tableau_elements_base[didi-1].synonyme;
aqueux: sgreactifs.Cells[1,i]:=
tableau_elements_aqueux[didi-1].synonyme;
gaz: sgreactifs.Cells[1,i]:=
tableau_elements_gazeux[didi-1].synonyme;
solide: sgreactifs.Cells[1,i]:=
tableau_elements_mineraux[didi-1].synonyme;
organique: sgreactifs.Cells[1,i]:=
tableau_elements_organiques[didi-1].synonyme;
end;


sgreactifs.AutoSizeColumns;

  end;
toto.Free;



end;

procedure TForm9.FormCreate(Sender: TObject);
begin
  id9:='';
sgreactifs.ColCount:=3;
  sgreactifs.RowCount:=2;
  sgreactifs.Cells[0,0]:='Identifiant';
  sgreactifs.Cells[2,0]:='M (g/mol)';
  sgreactifs.Cells[1,0]:='Synonyme';
 sgreactifs.AutoSizeColumns;
  //editformulebrute.SetFocus;
end;

procedure TForm9.FormShow(Sender: TObject);
begin
 // scalefont(self);
end;

procedure TForm9.sgreactifsMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var  i,coco,roro:integer;
deja_entre:boolean;
repmode:integer;
label 555,666;
  begin
sgreactifs.MouseToCell(x,y,coco,roro);
if ((roro>0)   and (roro<=sgreactifs.rowcount-1) and
(coco>=0) and (coco<=sgreactifs.ColCount-1)
and( sgreactifs.Cells[0,roro]<>'') )  then
begin
id9:=sgreactifs.Cells[0,roro];
close;
end;

end;

initialization
  {$I unit9.lrs}

end.

